@Route("binder")
public class BinderExampleView extends VerticalLayout {
    public static class ExampleBean{
        private String str1;
        private InnerClass vals;
        public String getStr1() {
            return str1;
        }
        public void setStr1(String str1) {
            this.str1 = str1;
        }
        public InnerClass getVals() {
            return vals;
        }
        public void setVals(InnerClass vals) {
            this.vals = vals;
        }
    }
    public static class InnerClass{
        private String val1 = "Val1";
        private String val2 = " Val2";
        @Override
        public String toString() {
            return val1 + val2;
        }
    }
    public BinderExampleView() {
        TextField theTextField = new TextField();
        TextField theTextField2 = new TextField();
        Binder<ExampleBean> binder = new Binder<>(ExampleBean.class);
        Converter<String, InnerClass> converter = new Converter<String, InnerClass>() {
            @Override
            public Result<InnerClass> convertToModel(String value, ValueContext context) {
                return Result.ok(null);
            }
            @Override
            public String convertToPresentation(InnerClass value, ValueContext context) {
                return value != null ? value.toString() : null;
            }
        } ;
        //custom converter...
        binder.forField(theTextField).withNullRepresentation("").withConverter(converter).bind("vals").setReadOnly(true);
        binder.forField(theTextField2).withNullRepresentation("").bind("str1");
        add(theTextField);
        add(theTextField2);
        ExampleBean bean = new ExampleBean();
        bean.setStr1("Find me!");
        bean.setVals(new InnerClass());
        binder.setBean(bean);
        // Click on setBean to make the vals value in
        // the read-only field disappear
        add(new Button("Set bean", e ->{
            binder.setBean(bean);
            System.out.println("Bean has vals value: " + bean.getVals());
        }));
    }
}